#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuild_ctype4xi.py"> 
#<abstract4xi abstract = "providing function rebuild_ctype4xi"/>
#<refer4xi reference = "sharedctypes.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'rebuild_ctype4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref         
except:
    pass
try:                 # rare ones
    import ctypes      
except:
    pass 
   
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.sharedctypes import rebuild_ctype 
except:
    print("rebuild_ctype4xi.py: *** failed in from multiprocessing.sharedctypes import rebuild_ctype ***")   
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from assert_spawning4xi import assert_spawning4xi
from examine4xi import examine4xi
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_ctype4xi" usage = "
#   rebuild_ctype4xi.py <-- EMBEDDED function to avoid recursion!                              
#       ForkingPickler.register(type_, reduce_ctype4xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reduce_ctype4xi(obj):
    '''
    EMBEDDED function to be registered to ForkingPickler thereby avoiding recursion problems!
    '''
    # -----------------------------------------------------------------------------------------    
    # (Step 1/3)
    # -----------------------------------------------------------------------------------------     
    class2print = "reduce_ctype4xi"
    method2print = "reduce_ctype4xi"

    message2print = "{started" + "; reduce-ctype4xi-started: " + str(reduce_ctype4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; object-passed-to-reduce-ctype4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
           
       
    message2print = "{(Step 1/3a) passing" + "; object-passing-to-assert-spawning4xi-by-reduce-ctype4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
            
    assert_spawning4xi(obj)
    
    message2print = "{(Step 1/3b) performed" + "; assert-spawning4xi-performed-by-reduce-ctype4xi: " + str(assert_spawning4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
             
     
    
    if isinstance(obj, ctypes.Array):
    
        # -------------------------------------------------------------------------------------    
        # (Step 2/3)
        # -------------------------------------------------------------------------------------      
             
        message2print = "{(Step 2/3a) passing" + "; object-type-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._type_) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
               
        message2print = "{(Step 2/3b) passing" + "; object-wrapper-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._wrapper) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
                  
               
        message2print = "{(Step 2/3c) passing" + "; object-length-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._length_) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   

                 
        message2print = "{(Step 2/3d) returning" + "; rebuild-ctype4xi-function-returning-by-reduce-ctype4xi: " + str(rebuild_ctype4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                     
               
        return rebuild_ctype4xi, (obj._type_, obj._wrapper, obj._length_)
    else:
    
        # -------------------------------------------------------------------------------------    
        # (Step 3/3)
        # -------------------------------------------------------------------------------------      
        

        
        message2print = "{(Step 3/3a) passing" + "; type-object-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(type(obj)) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{(Step 3/3a) passing" + "; wrapper-object-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._wrapper) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
                 
        message2print = "{(Step 3/3a) returning" + "; rebuild-ctype4xi-function-returning-by-reduce-ctype4xi: " + str(rebuild_ctype4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
        return rebuild_ctype4xi, (type(obj), obj._wrapper, None)
     
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
           
        
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "rebuild_ctype4xi" usage = "
#     sharedctypes.py
#         called by _new_value(type_): return rebuild_ctype(type_, wrapper, None)
#"> 
# -------------------------------------------------------------------------------------------------
def rebuild_ctype4xi(type_, wrapper, length):
    '''
    rebuild_ctype4xi function in sharedctypes.py called by _new_value(type_): return rebuild_ctype(type_, wrapper, None)
    '''

    # -----------------------------------------------------------------------------------------    
    # (Step 1/7) 
    # -----------------------------------------------------------------------------------------        
      
    class2print = "rebuild_ctype4xi"
    method2print = "rebuild_ctype4xi"
 
    message2print = "{(Step 1/7a) started" + "; rebuild-ctype4xi-started: " + str(rebuild_ctype4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function rebuild_ctype4xi at 0x000000000364C6A8>
        
    message2print = "{(Step 1/7b) passed" + "; type-passed-to-rebuild-ctype4xi: " + str(type_) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <class 'ctypes.c_long'>
            
    message2print = "{(Step 1/7c) passed" + "; wrapper-passed-to-rebuild-ctype4xi: " + str(wrapper) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <bufferwrapper4xi.BufferWrapper4Xi object at 0x00000000039A4EB8>
        
    message2print = "{(Step 1/7d) passed" + "; length-passed-to-rebuild-ctype4xi: " + str(length) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # None               
    
    if examine4xi(class2print, method2print):  
    
        # -------------------------------------------------------------------------------------    
        # StepOriginal
        # -------------------------------------------------------------------------------------             
        message2print = "{(StepOriginal) performing" + "; rebuild_ctype-performing-by-rebuild_ctype4xi: " + str(rebuild_ctype) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
            
                         
        return rebuild_ctype(type_, wrapper, length)
        
    else:                 
        # -----------------------------------------------------------------------------------------    
        # (Step 2/7) 
        # -----------------------------------------------------------------------------------------        
        if length is not None:
            type_ = type_ * length
            
            message2print = "{(Step 2/7) set" + "; type-set-by-rebuild-ctype4xi to: " + str(type_)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #  
                    
        # -----------------------------------------------------------------------------------------    
        # (Step 3/7) 
        # -----------------------------------------------------------------------------------------        
        try:
            message2print = "{(Step 3a/7) passing" + "; reduce_ctype4xi-passing-to-ForkingPickler4Xi-registe-by-rebuild-ctype4xi: " + str(reduce_ctype4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # <function reduce_ctype4xi at 0x00000000031E4488>
            
            message2print = "{(Step 3b/7) passing" + "; type-passing-to-ForkingPickler4Xi-registe-by-rebuild-ctype4xi: " + str(type_) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # <class 'ctypes.c_long'>
        except:
            pass   
    
        ForkingPickler4Xi.register(type_, reduce_ctype4xi)
        
        message2print = "{(Step 3c/7) performed" + "; ForkingPickler4Xi-register-performed-by-rebuild-ctype4xi: " + str(ForkingPickler4Xi.register) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <bound method type.register of <class 'forkingpickler4xi.ForkingPickler4Xi'>>
        
        # -----------------------------------------------------------------------------------------    
        # (Step 4/7)
        # -----------------------------------------------------------------------------------------        
        buf2xi = None
        try:
            buf2xi = wrapper.create_memoryview()
            message2print = "{(Step 4a/7) set" + "; buf2xi-set-by-rebuild-ctype4xi to: " + str(buf2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # <memory at 0x0000000003A28E58>
        except:
            message2print = "{(Step 4z/7) failed" + "; buf2xi-failed-by-rebuild-ctype4xi to: " + str(buf2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/7)
        # -----------------------------------------------------------------------------------------        
        obj2xi = None
        try:
            obj2xi = type_.from_buffer(buf2xi)
            
            message2print = "{(Step 5a/7) set" + "; obj2xi-set-by-rebuild-ctype4xi to: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # c_long(0)
            
        except:
            message2print = "{(Step 5z/7) failed" + "; obj2xi-failed-by-rebuild-ctype4xi: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        
        
        # -----------------------------------------------------------------------------------------    
        # (Step 6/7) 
        # -----------------------------------------------------------------------------------------        
        if obj2xi is None:
            message2print = "{(Step 6z/7) failing" + "; obj2xi-wrapped-failing-by-rebuild-ctype4xi: " + str(obj2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:    
            
            obj2xi._wrapper = wrapper
            
            message2print = "{(Step 6a/7) set" + "; obj2xi-wrapper-set-by-rebuild-ctype4xi to: " + str(obj2xi._wrapper)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # <bufferwrapper4xi.BufferWrapper4Xi object at 0x00000000039A4EB8>
            
        
        
        # -----------------------------------------------------------------------------------------    
        # (Step 7/7) 
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 7/7) returning" + "; obj2xi-returning-by-rebuild-ctype4xi: " + str(obj2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # c_long(0)
        
        return obj2xi
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuild_ctype4xi.pyrebuild_ctype4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>